<template>
  <div class="app-container">
    <div ref="topContainerRef">
    <TableSearch
        :queryParams="queryParams"
        queryRef="queryRef"
        :showSearch="showSearch"
        @search="handleQuery"
        @refresh="resetQuery"
        label-width="80px"
    >
      <template #one>
        <el-col :xs="24" :sm="24" :md="12" :lg="6" :xl="6" :xxl="6">
          <el-form-item label="终端名称" prop="name">
            <el-input
                v-model="queryParams.name"
                placeholder="请输入终端名称"
                style="width:100%"
                clearable
                @keyup.enter="handleQuery"
            />
          </el-form-item>
        </el-col>
        <el-col :xs="24" :sm="24" :md="12" :lg="6" :xl="6" :xxl="6">
          <el-form-item label="端口号" prop="port">
            <el-input
                v-model="queryParams.port"
                placeholder="请输入端口号"
                style="width:100%"
                clearable
                @keyup.enter="handleQuery"
            />
          </el-form-item>
        </el-col>
      </template>
    </TableSearch>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
            type="primary"
            plain
            icon="Plus"
            @click="handleAdd"
            v-hasPermi="['device:terminal:add']"
        >新增
        </el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
            type="success"
            plain
            icon="Edit"
            :disabled="single"
            @click="handleUpdate"
            v-hasPermi="['device:terminal:edit']"
        >修改
        </el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
            type="danger"
            plain
            icon="Delete"
            :disabled="multiple"
            @click="handleDelete"
            v-hasPermi="['device:terminal:remove']"
        >删除
        </el-button>
      </el-col>
      <!--      <el-col :span="1.5">-->
      <!--        <el-button-->
      <!--            type="warning"-->
      <!--            plain-->
      <!--            icon="Download"-->
      <!--            @click="handleExport"-->
      <!--            v-hasPermi="['device:terminal:export']"-->
      <!--        >导出-->
      <!--        </el-button>-->
      <!--      </el-col>-->
      <right-toolbar v-model:showSearch="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>
  </div>

  <div :style="containerHeight">
    <el-table height="100%" v-loading="loading" :data="terminalList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center"/>
      <el-table-column show-overflow-tooltip label="id" align="center" prop="id"/>
      <el-table-column label="终端名称" align="center" prop="name" show-overflow-tooltip/>
      <el-table-column label="主机" align="center" prop="host" show-overflow-tooltip/>
      <el-table-column label="端口号" align="center" prop="port" show-overflow-tooltip/>
      <el-table-column label="说明" align="center" prop="description" show-overflow-tooltip/>
      <el-table-column label="备注" align="center" prop="remake" show-overflow-tooltip/>
      <el-table-column label="状态" align="center" prop="status">
        <template #default="scope">
          <el-switch
              v-model="scope.row.status"
              inline-prompt
              active-text="启用"
              inactive-text="停用"
              active-value="0"
              inactive-value="1"
              @change="handleChange(scope.row)"
          />
        </template>
      </el-table-column>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template #default="scope">
          <el-button link type="primary" icon="Edit" @click="handleUpdate(scope.row)"
                     v-hasPermi="['device:terminal:edit']">修改
          </el-button>

          <el-button link type="primary" icon="Delete" @click="handleDelete(scope.row)"
                     v-hasPermi="['device:terminal:remove']">删除
          </el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
        v-show="total>0"
        :total="total"
        v-model:page="queryParams.pageNum"
        v-model:limit="queryParams.pageSize"
        @pagination="getList"
    />
  </div>

    <!-- 添加或修改设备终端配置对话框 -->
    <el-dialog :title="title" v-model="open" width="500px" append-to-body>
      <el-form ref="terminalRef" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="终端名称" prop="name">
          <el-input v-model="form.name" placeholder="请输入终端名称"/>
        </el-form-item>
        <el-form-item label="主机" prop="host">
          <el-input v-model="form.host" placeholder="请输入主机"/>
        </el-form-item>
        <el-form-item label="端口号" prop="port">
          <el-input v-model="form.port" placeholder="请输入端口号"/>
        </el-form-item>
        <el-form-item label="说明" prop="description">
          <el-input v-model="form.description" placeholder="请输入说明"/>
        </el-form-item>
        <el-form-item label="备注" prop="remake">
          <el-input :rows="2"
                    type="textarea" v-model="form.remake" placeholder="请输入备注"/>
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="Terminal">
import {listTerminal, getTerminal, delTerminal, addTerminal, updateTerminal} from "@/api/device/terminal"
import TableSearch from "@/components/TableSearch/index.vue"

import { useContainerHeight } from "@/hooks/tableHeight";

const topContainerRef = ref();
const containerHeight = useContainerHeight(topContainerRef);

const {proxy} = getCurrentInstance()

const terminalList = ref([])
const open = ref(false)
const loading = ref(true)
const showSearch = ref(true)
const ids = ref([])
const single = ref(true)
const multiple = ref(true)
const total = ref(0)
const title = ref("")

const data = reactive({
  form: {},
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    remake: null,
    name: null,
    host: null,
    port: null,
    status: null,
    description: null
  },
  rules: {}
})

const {queryParams, form, rules} = toRefs(data)

/** 查询设备终端配置列表 */
function getList() {
  loading.value = true
  listTerminal(queryParams.value).then(response => {
    terminalList.value = response.rows
    total.value = response.total
    loading.value = false
  })
}

// 取消按钮
function cancel() {
  open.value = false
  reset()
}

// 表单重置
function reset() {
  form.value = {
    // id: null,
    // createBy: null,
    // createTime: null,
    // updateBy: null,
    // updateTime: null,
    // remake: null,
    // name: null,
    // host: null,
    // port: null,
    // status: null,
    // description: null
  }
  proxy.resetForm("terminalRef")
}

/** 搜索按钮操作 */
function handleQuery() {
  queryParams.value.pageNum = 1
  getList()
}

/** 重置按钮操作 */
function resetQuery() {
  proxy.resetForm("queryRef")
  handleQuery()
}

// 多选框选中数据
function handleSelectionChange(selection) {
  ids.value = selection.map(item => item.id)
  single.value = selection.length != 1
  multiple.value = !selection.length
}

/** 新增按钮操作 */
function handleAdd() {
  reset()
  open.value = true
  title.value = "添加设备终端配置"
}

/** 修改按钮操作 */
function handleUpdate(row) {
  reset()
  const _id = row.id || ids.value
  getTerminal(_id).then(response => {
    form.value = response.data
    open.value = true
    title.value = "修改设备终端配置"
  })
}

/** 提交按钮 */
function submitForm() {
  proxy.$refs["terminalRef"].validate(valid => {
    if (valid) {
      if (form.value.id != null) {
        updateTerminal(form.value).then(response => {
          proxy.$modal.msgSuccess("修改成功")
          open.value = false
          getList()
        })
      } else {
        addTerminal(form.value).then(response => {
          proxy.$modal.msgSuccess("新增成功")
          open.value = false
          getList()
        })
      }
    }
  })
}

/** 删除按钮操作 */
function handleDelete(row) {
  const _ids = row.id || ids.value
  proxy.$modal.confirm('是否确认删除设备终端配置编号为"' + _ids + '"的数据项？').then(function () {
    return delTerminal(_ids)
  }).then(() => {
    getList()
    proxy.$modal.msgSuccess("删除成功")
  }).catch(() => {
  })
}

/** 导出按钮操作 */
function handleExport() {
  proxy.download('device/terminal/export', {
    ...queryParams.value
  }, `terminal_${new Date().getTime()}.xlsx`)
}

function handleChange(row) {
  updateTerminal({status: row.status, id: row.id}).then(response => {
    proxy.$modal.msgSuccess("修改成功")
    getList()
  })
}

getList()
</script>
